package ru.dbotthepony.kstarbound

import kotlinx.coroutines.future.future
import org.apache.logging.log4j.LogManager
import org.lwjgl.Version
import ru.dbotthepony.kommons.io.ByteKey
import ru.dbotthepony.kommons.util.AABBi
import ru.dbotthepony.kommons.vector.Vector2d
import ru.dbotthepony.kommons.vector.Vector2i
import ru.dbotthepony.kstarbound.client.StarboundClient
import ru.dbotthepony.kstarbound.io.BTreeDB5
import ru.dbotthepony.kstarbound.server.IntegratedStarboundServer
import ru.dbotthepony.kstarbound.server.world.LegacyWorldStorage
import ru.dbotthepony.kstarbound.server.world.ServerUniverse
import ru.dbotthepony.kstarbound.server.world.ServerWorld
import ru.dbotthepony.kstarbound.util.random.random
import ru.dbotthepony.kstarbound.util.random.staticRandomDouble
import ru.dbotthepony.kstarbound.world.WorldGeometry
import java.io.BufferedInputStream
import java.io.ByteArrayInputStream
import java.io.DataInputStream
import java.io.File
import java.net.InetSocketAddress
import java.util.zip.Inflater
import java.util.zip.InflaterInputStream

private val LOGGER = LogManager.getLogger()

fun main() {
	Starbound.addPakPath(File("J:\\Steam\\steamapps\\common\\Starbound\\assets\\packed.pak"))
	Starbound.doBootstrap()

	LOGGER.info("Running LWJGL ${Version.getVersion()}")

	// println(VersionedJson(meta))

	val client = StarboundClient.create().get()
	Starbound.initializeGame()

	Starbound.mailboxInitialized.submit {
		val server = IntegratedStarboundServer(client, File("./"))
		server.channels.createChannel(InetSocketAddress(21060))
	}
}
