package ru.dbotthepony.kstarbound.world.entities.wire

import ru.dbotthepony.kommons.io.StreamCodec
import ru.dbotthepony.kommons.io.readVector2i
import ru.dbotthepony.kommons.io.writeStruct2i
import ru.dbotthepony.kommons.io.writeVarLong
import ru.dbotthepony.kommons.vector.Vector2i
import ru.dbotthepony.kstarbound.network.syncher.SizeTCodec
import java.io.DataInputStream
import java.io.DataOutputStream

data class WireConnection(val entityLocation: Vector2i, val index: Int = -1) {
	constructor(stream: DataInputStream) : this(stream.readVector2i(), SizeTCodec.read(stream).toInt())

	fun write(stream: DataOutputStream) {
		stream.writeStruct2i((entityLocation))
		SizeTCodec.write(stream, index.toLong())
	}

	companion object {
		val CODEC = StreamCodec.Impl(::WireConnection, { a, b -> b.write(a) })
	}
}
